<?php

namespace Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\ram;

/**
 * Class representing TradeAllowanceChargeType
 *
 * XSD Type: TradeAllowanceChargeType
 */
class TradeAllowanceChargeType
{

    /**
     * @var \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\IndicatorType $chargeIndicator
     */
    private $chargeIndicator = null;

    /**
     * @var float $calculationPercent
     */
    private $calculationPercent = null;

    /**
     * @var \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType $basisAmount
     */
    private $basisAmount = null;

    /**
     * @var \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType $actualAmount
     */
    private $actualAmount = null;

    /**
     * @var string $reasonCode
     */
    private $reasonCode = null;

    /**
     * @var string $reason
     */
    private $reason = null;

    /**
     * @var \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\ram\TradeTaxType $categoryTradeTax
     */
    private $categoryTradeTax = null;

    /**
     * Gets as chargeIndicator
     *
     * @return \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\IndicatorType
     */
    public function getChargeIndicator()
    {
        return $this->chargeIndicator;
    }

    /**
     * Sets a new chargeIndicator
     *
     * @param  \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\IndicatorType $chargeIndicator
     * @return self
     */
    public function setChargeIndicator(\Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\IndicatorType $chargeIndicator)
    {
        $this->chargeIndicator = $chargeIndicator;
        return $this;
    }

    /**
     * Gets as calculationPercent
     *
     * @return float
     */
    public function getCalculationPercent()
    {
        return $this->calculationPercent;
    }

    /**
     * Sets a new calculationPercent
     *
     * @param  float $calculationPercent
     * @return self
     */
    public function setCalculationPercent($calculationPercent)
    {
        $this->calculationPercent = $calculationPercent;
        return $this;
    }

    /**
     * Gets as basisAmount
     *
     * @return \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType
     */
    public function getBasisAmount()
    {
        return $this->basisAmount;
    }

    /**
     * Sets a new basisAmount
     *
     * @param  \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType $basisAmount
     * @return self
     */
    public function setBasisAmount(?\Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType $basisAmount = null)
    {
        $this->basisAmount = $basisAmount;
        return $this;
    }

    /**
     * Gets as actualAmount
     *
     * @return \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType
     */
    public function getActualAmount()
    {
        return $this->actualAmount;
    }

    /**
     * Sets a new actualAmount
     *
     * @param  \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType $actualAmount
     * @return self
     */
    public function setActualAmount(\Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\udt\AmountType $actualAmount)
    {
        $this->actualAmount = $actualAmount;
        return $this;
    }

    /**
     * Gets as reasonCode
     *
     * @return string
     */
    public function getReasonCode()
    {
        return $this->reasonCode;
    }

    /**
     * Sets a new reasonCode
     *
     * @param  string $reasonCode
     * @return self
     */
    public function setReasonCode($reasonCode)
    {
        $this->reasonCode = $reasonCode;
        return $this;
    }

    /**
     * Gets as reason
     *
     * @return string
     */
    public function getReason()
    {
        return $this->reason;
    }

    /**
     * Sets a new reason
     *
     * @param  string $reason
     * @return self
     */
    public function setReason($reason)
    {
        $this->reason = $reason;
        return $this;
    }

    /**
     * Gets as categoryTradeTax
     *
     * @return \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\ram\TradeTaxType
     */
    public function getCategoryTradeTax()
    {
        return $this->categoryTradeTax;
    }

    /**
     * Sets a new categoryTradeTax
     *
     * @param  \Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\ram\TradeTaxType $categoryTradeTax
     * @return self
     */
    public function setCategoryTradeTax(\Itdatex\EInvoiceCore\Vendor\horstoeko\zugferd\entities\basicwl\ram\TradeTaxType $categoryTradeTax)
    {
        $this->categoryTradeTax = $categoryTradeTax;
        return $this;
    }
}
